/** myDatabase.java
 *
 * This class provides methods to access the Oracle database via JDBC
 * API:  void open(), void close(), executeSQL(String sql), getRecord(String sql) 
 * Exceptions are printed.
 *
 * @author xjqiu@npac.syr.edu 
 */
package cy99xfq.myServlet;

import java.sql.*;
import java.util.Properties;
import java.util.*;

class myDatabase {
  
  private Connection conn;
  
  public void open() {  //Open the connection to DB
    try {
      Class.forName("oracle.jdbc.driver.OracleDriver");
      conn = DriverManager.getConnection
          ("jdbc:oracle:thin:@carver.npac.syr.edu:1521:europe", "cy99xfq", "cy99xfq");
      System.out.println("Connection Open");
    }
    catch (Exception e) { System.err.println("Error connection: " + e);}
  }
  

  public int getMaxId(String sql) { //Get the Maxium id from records returned 

      int i = 0;
      try {
      	Statement stmt = conn.createStatement();
      	ResultSet rs = stmt.executeQuery(sql);
        if(rs == null) return -1;
      	rs.next();
      	i = rs.getInt("max(id)");
      	rs.close();
      	stmt.close();
      }catch(Exception e) {
          e.printStackTrace(System.out);
          return -1;
      }
      return i;
  }

 public int executeSQL(String sql) { // Execute Query operation by input sql string 
    int i = -1;
    try {
        Statement stmt = conn.createStatement();
        stmt.execute(sql);
        i = 1;
        stmt.close();
    }catch(Exception e) {
        System.out.println("Exception in updating record");
        e.printStackTrace(System.out);
    }
    return i;
 }

  public Vector getRecords(String sql) {//Return all records that matches the given name/phone field

      Vector vec = new Vector();
      Hashtable ht = new Hashtable();

      try {
      Statement stmt = conn.createStatement();
      ResultSet rs = stmt.executeQuery(sql);

      while(rs.next()) {
          ht.put("id",new Integer(rs.getInt("id")));
          ht.put("imgname",rs.getString("imgname"));
          ht.put("color",rs.getString("color"));
          ht.put("type",rs.getString("type"));
          ht.put("url",rs.getString("url"));
          vec.addElement(ht.clone());
          System.out.println("Hashtable inside getRec = "+ht);
          ht.clear();
      }
      rs.close();
      stmt.close();
      }catch(Exception e) {
          System.out.println(e.getMessage());
          System.out.println("Exception inside getRecords...");

      }

      return vec;
  }
  
  public void close() { //Close connection to DB
    
	try {
      conn.close();
      System.out.println("Connection Closed");
    }
    catch (Exception e) {System.err.println("Error in closing dbase");}
  }
}

